const fs = require('fs');

var cache = {},
	path = 'db',
	methods = {
		set: (key, value) => dbNew(key, value, true),
		get: key => cache[key],
		delete: key => dbNew(key)
	};

module.exports = Object.assign(
	{
		path: value => (path = value) && methods
	},
	methods
);

path = path + '.json';

if (fs.existsSync(path)) {
	let data = fs.readFileSync(path, 'utf8');

	if (!data) cache = {};
	else cache = JSON.parse(data);
} else cache = {};

function dbNew(key, value, settable) {
	if (settable) cache[key] = value;
	else delete cache[key];

	return new Promise((res, rej) => {
		fs.writeFile(
			path,
			JSON.stringify(cache),
			err => (err ? rej(err) : res(true))
		);
	});
}
